//
//  Demo2ViewController.m
//  Scene Kit Demo 2
//
//  Created by Demitri Muna on 9/13/12.
//  Copyright (c) 2012 Demitri Muna. All rights reserved.
//

#import "Demo2ViewController.h"
#import <SceneKit/SceneKit.h>

@interface Demo2ViewController ()

@end

@implementation Demo2ViewController

- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        // Initialization code here.
    }
    
    return self;
}

- (void)awakeFromNib
{
	SCNView *sceneView = (SCNView *)self.view;
	sceneView.backgroundColor = [NSColor colorWithCalibratedWhite:0.284 alpha:1.0];
	sceneView.allowsCameraControl = YES;
	
	// create an empty scene and set it to the view
	SCNScene *scene = [SCNScene scene];
	sceneView.scene = scene;
	
	// Create a camera
	// ---------------
	SCNCamera *camera = [SCNCamera camera];
	
	// set field of view - can make wide or narrow
	camera.xFov = 45;   // Degrees, not radians
	camera.yFov = 45;
	
	// create a node for the camera
	SCNNode *cameraNode = [SCNNode node];
	cameraNode.camera = camera;
	cameraNode.position = SCNVector3Make(0, 0, 30);
	
	// add camera to root node
	[scene.rootNode addChildNode:cameraNode];

	// Text
	// ----
	SCNText *text = [SCNText textWithString:@"CocoaHeads" extrusionDepth:5.f];
	SCNNode *textNode = [SCNNode nodeWithGeometry:text];
	text.font = [NSFont fontWithName:@"Avenir Next Heavy" size:10.];
	text.chamferRadius = 0.2f;

	textNode.position = SCNVector3Make(-35, -4, 0); // default at origin
	//textNode.transform = CATransform3DScale(textNode.transform, .1f, .1f, .1f);
	
	SCNMaterial *textMaterial = [SCNMaterial material];
	textMaterial.diffuse.contents = [NSImage imageNamed:@"iras-100um.jpg"];
	textMaterial.ambient.contents = [NSColor blueColor];
	text.materials = @[textMaterial];

	[scene.rootNode addChildNode:textNode];

	// Floor
	// -----
	SCNFloor *floor = [SCNFloor floor];
	SCNNode *floorNode = [SCNNode nodeWithGeometry:floor];
	[scene.rootNode addChildNode:floorNode];
	
	// Create a diffuse light (omnidirectional)
	SCNLight *diffuseLight = [SCNLight light];
	SCNNode *diffuseLightNode = [SCNNode node];
	diffuseLight.type = SCNLightTypeOmni;
	diffuseLightNode.light = diffuseLight;
	diffuseLightNode.position = SCNVector3Make(-30, 30, 50);
	[scene.rootNode addChildNode:diffuseLightNode];
	
	
	
}

@end
