//
//  DMSceneView.m
//  SceneKitPlayground
//
//  Created by Demitri Muna on 29/08/2012.
//  Copyright (c) 2012 Demitri Muna. All rights reserved.
//

#define PI 3.14159265358979323846
#define deg2rad(DEG) ((DEG)*((PI)/(180.0)))

#import "DMSceneView.h"

@implementation DMSceneView

- (id)initWithFrame:(NSRect)frame
{
    self = [super initWithFrame:frame];
    if (self) {
        // Initialization code here.
    }
    
    return self;
}

/*
- (void)drawRect:(NSRect)dirtyRect
{
    // Drawing code here.
}
*/
- (void)awakeFromNib
{
	//self.backgroundColor = [NSColor colorWithCalibratedWhite:0.284 alpha:1.0];
	self.backgroundColor = [NSColor colorWithCalibratedWhite:0 alpha:1.0];
	self.allowsCameraControl = YES;
	
	// Create an empty scene
	SCNScene *scene = [SCNScene scene];
	self.scene = scene;
	
	// Create a camera
	SCNCamera *camera = [SCNCamera camera];
	camera.xFov = 45;   // Degrees, not radians
	camera.yFov = 45;
	SCNNode *cameraNode = [SCNNode node];
	cameraNode.camera = camera;
	cameraNode.position = SCNVector3Make(0, 0, 30);
	[scene.rootNode addChildNode:cameraNode];
	
	/*
	// Create a torus
	SCNTorus *torus = [SCNTorus torusWithRingRadius:8 pipeRadius:1.5];
	SCNNode *torusNode = [SCNNode nodeWithGeometry:torus];
	CATransform3D torusRot = CATransform3DMakeRotation(deg2rad(45), 1, 0, 0);
	torusNode.transform = torusRot;
	[scene.rootNode addChildNode:torusNode];
	
	// Give the Torus a child
	SCNText *text = [SCNText textWithString:@"Bullwinkle!" extrusionDepth:40.f];
	self.textNode = [SCNNode nodeWithGeometry:text];
	self.textNode.position = SCNVector3Make(-10, 5, 0);
	self.textNode.transform = CATransform3DScale(self.textNode.transform, .1f, .1f, .1f);
	[torusNode addChildNode:self.textNode];
*/	
	// Create a sphere
	self.sphere = [SCNSphere sphereWithRadius:10];
	self.sphereNode = [SCNNode nodeWithGeometry:self.sphere];
	CATransform3D rotation = CATransform3DMakeRotation(deg2rad(45), 1, 0, 0);
	self.sphereNode.transform = rotation;
	[scene.rootNode addChildNode:self.sphereNode];
	
	self.sphereMaterial = [SCNMaterial material];
	self.sphereMaterial.diffuse.contents = [NSImage imageNamed:@"eso0932a.png"]; // colors shown when hit by duffuse light - image, or NSColor
	//self.sphereMaterial.specular.contents = [NSColor yellowColor]; // colors shown when hit by specular light
	self.sphereMaterial.ambient.contents = [NSImage imageNamed:@"eso0932a.png"]; // colors shown when hit by duffuse light - image, or NSColor
	//self.sphereMaterial.shininess = 100; // shape of specular highlight
	self.sphere.materials = @[self.sphereMaterial];

    self.atmosphere = [SCNSphere sphereWithRadius:10.2];
	self.atmosphereNode = [SCNNode nodeWithGeometry:self.atmosphere];
	/*self.atmosphereNode.transform = rotation;*/
	[scene.rootNode addChildNode:self.atmosphereNode];
	
	SCNMaterial *atmosphereMaterial = [SCNMaterial material];
    NSImage *opacityImage = [NSImage imageNamed:@"AtmosMap.png"];
    atmosphereMaterial.transparent.contents = opacityImage;
	atmosphereMaterial.diffuse.contents = [NSColor colorWithCalibratedRed:1 green:1 blue:1 alpha:1.0]; // colors shown when hit by duffuse light - image, or NSColor
	atmosphereMaterial.specular.contents = [NSColor colorWithCalibratedRed:1 green:1 blue:1 alpha:1.0]; // colors shown when hit by specular light
	//atmosphereMaterial.ambient.contents = [NSColor colorWithCalibratedRed:1 green:1 blue:1 alpha:0.5]; // colors shown when hit by duffuse light - image, or NSColor
	//self.sphereMaterial.shininess = 100; // shape of specular highlight
	self.atmosphere.materials = @[atmosphereMaterial];

    
    
	// arrow
	/*SCNText *textArrow = [SCNText textWithString:@"➜" extrusionDepth:3.f];
	SCNNode *textArrowNode = [SCNNode nodeWithGeometry:textArrow];
	textArrowNode.position = SCNVector3Make(10, 10*cos(0.785398163), 0);
	textArrowNode.transform = CATransform3DScale(textArrowNode.transform, .05f, .05f, .05f);
	[self.sphereNode addChildNode:textArrowNode];*/

	// arrow color
	/*SCNMaterial *arrowMaterial = [SCNMaterial material];
	arrowMaterial.ambient.contents = [NSColor blueColor];
	textArrow.materials = @[arrowMaterial];*/
	
	// Create ambient light
	SCNLight *ambientLight = [SCNLight light];
	SCNNode *ambientLightNode = [SCNNode node];
	ambientLight.type = SCNLightTypeAmbient;
	ambientLight.color = [NSColor colorWithCalibratedRed:0.04 green: 0.04 blue:0.05 alpha:1.0];
	ambientLightNode.light = ambientLight;
	[scene.rootNode addChildNode:ambientLightNode];
	
	/*SCNLight *specularLight = [SCNLight light];
	 SCNNode *specularLightNode = [SCNNode node];
	 specularLight.type = SCNLightTypeDirectional;
	 specularLight.color = [NSColor greenColor];
	 specularLightNode.light = specularLight;
	 [scene.rootNode addChildNode:specularLightNode];*/
	
	// Create a diffuse light
	SCNLight *diffuseLight = [SCNLight light];
	SCNNode *diffuseLightNode = [SCNNode node];
	diffuseLight.type = SCNLightTypeOmni;
    diffuseLight.color = [NSColor colorWithCalibratedRed:1.0 green: 1.0 blue:1.0 alpha:1.0];
    [diffuseLight setAttribute:[NSNumber numberWithFloat:0]
                        forKey:SCNLightAttenuationFalloffExponentKey];
	diffuseLightNode.light = diffuseLight;
	diffuseLightNode.position = SCNVector3Make(-30, 30, 50);
	[scene.rootNode addChildNode:diffuseLightNode];

    SCNLight *diffuseLight2 = [SCNLight light];
	SCNNode *diffuseLightNode2 = [SCNNode node];
	diffuseLight2.type = SCNLightTypeOmni;
    [diffuseLight2 setAttribute:[NSNumber numberWithFloat:3]
                         forKey:SCNLightAttenuationFalloffExponentKey];
    diffuseLight2.color = [NSColor colorWithCalibratedRed:0.08 green: 0.08 blue:0.1 alpha:1.0];
	diffuseLightNode2.light = diffuseLight2;
	diffuseLightNode2.position = SCNVector3Make(60, -60, -100);

	[scene.rootNode addChildNode:diffuseLightNode2];

    /*
	CAKeyframeAnimation *animation = [CAKeyframeAnimation animationWithKeyPath:@"transform"];
	animation.values = [NSArray arrayWithObjects:
						[NSValue valueWithCATransform3D:CATransform3DRotate(torusNode.transform, 0 * M_PI / 2, 1.f, 0.5f, 0.f)],
						[NSValue valueWithCATransform3D:CATransform3DRotate(torusNode.transform, 1 * M_PI / 2, 1.f, 0.5f, 0.f)],
						[NSValue valueWithCATransform3D:CATransform3DRotate(torusNode.transform, 2 * M_PI / 2, 1.f, 0.5f, 0.f)],
						[NSValue valueWithCATransform3D:CATransform3DRotate(torusNode.transform, 3 * M_PI / 2, 1.f, 0.5f, 0.f)],
						[NSValue valueWithCATransform3D:CATransform3DRotate(torusNode.transform, 4 * M_PI / 2, 1.f, 0.5f, 0.f)],
						nil];
	animation.duration = 3.f;
	animation.repeatCount = HUGE_VALF;
	
	//[torusNode addAnimation:animation forKey:@"transform"];
*/
	CAKeyframeAnimation *sphereAnimation = [CAKeyframeAnimation animationWithKeyPath:@"transform"];
	sphereAnimation.values = [NSArray arrayWithObjects:
						[NSValue valueWithCATransform3D:CATransform3DRotate(self.sphereNode.transform, 0 * M_PI / 2, 1.f, 0.5f, 0.f)],
						[NSValue valueWithCATransform3D:CATransform3DRotate(self.sphereNode.transform, 1 * M_PI / 2, 1.f, 0.5f, 0.f)],
						[NSValue valueWithCATransform3D:CATransform3DRotate(self.sphereNode.transform, 2 * M_PI / 2, 1.f, 0.5f, 0.f)],
						[NSValue valueWithCATransform3D:CATransform3DRotate(self.sphereNode.transform, 3 * M_PI / 2, 1.f, 0.5f, 0.f)],
						[NSValue valueWithCATransform3D:CATransform3DRotate(self.sphereNode.transform, 4 * M_PI / 2, 1.f, 0.5f, 0.f)],
						nil];
	sphereAnimation.duration = 10.f;
	sphereAnimation.repeatCount = HUGE_VALF;

    CAKeyframeAnimation *atmosphereAnimation = [CAKeyframeAnimation animationWithKeyPath:@"transform"];
	atmosphereAnimation.values = [NSArray arrayWithObjects:
                              [NSValue valueWithCATransform3D:CATransform3DRotate(self.atmosphereNode.transform, 0 * M_PI / 2, 1.f, 0.5f, 0.f)],
                              [NSValue valueWithCATransform3D:CATransform3DRotate(self.atmosphereNode.transform, 1 * M_PI / 2, 1.f, 0.5f, 0.f)],
                              [NSValue valueWithCATransform3D:CATransform3DRotate(self.atmosphereNode.transform, 2 * M_PI / 2, 1.f, 0.5f, 0.f)],
                              [NSValue valueWithCATransform3D:CATransform3DRotate(self.atmosphereNode.transform, 3 * M_PI / 2, 1.f, 0.5f, 0.f)],
                              [NSValue valueWithCATransform3D:CATransform3DRotate(self.atmosphereNode.transform, 4 * M_PI / 2, 1.f, 0.5f, 0.f)],
                              nil];
	atmosphereAnimation.duration = 9.f;
	atmosphereAnimation.repeatCount = HUGE_VALF;

	[self.sphereNode addAnimation:sphereAnimation forKey:@"transform"];
	[self.atmosphereNode addAnimation:atmosphereAnimation forKey:@"transform"];

	// Animate the text
	CAKeyframeAnimation *textAnimation = [CAKeyframeAnimation animationWithKeyPath:@"transform"];
	textAnimation.values = [NSArray arrayWithObjects:
							[NSValue valueWithCATransform3D:CATransform3DRotate(self.textNode.transform, 0 * M_PI / 2, 0.f, 0.5f, 1.f)],
							[NSValue valueWithCATransform3D:CATransform3DRotate(self.textNode.transform, 1 * M_PI / 2, 0.f, 0.5f, 1.f)],
							[NSValue valueWithCATransform3D:CATransform3DRotate(self.textNode.transform, 2 * M_PI / 2, 0.f, 0.5f, 1.f)],
							[NSValue valueWithCATransform3D:CATransform3DRotate(self.textNode.transform, 3 * M_PI / 2, 0.f, 0.5f, 1.f)],
							[NSValue valueWithCATransform3D:CATransform3DRotate(self.textNode.transform, 4 * M_PI / 2, 0.f, 0.5f, 1.f)],
							nil];
	textAnimation.duration = 3.f;
	textAnimation.repeatCount = HUGE_VALF;
	
	
	
	//[self.textNode addAnimation:textAnimation forKey:@"transform"];

}


- (void)selectNode:(SCNNode *)node geometryElementIndex:(NSUInteger)index {
    // Unhighlight the previous selection.
    [self.selectedMaterial.emission removeAllAnimations];
    
    // Clear the selection.
    self.selectedMaterial = nil;
    
    // Highight the selection, if there is one.
    if (node != nil) {
        // Convert the geometry element index to a material index.
        index = index % [node.geometry.materials count];
        
        // Make the material unique (i.e. unshared).
        SCNMaterial *unsharedMaterial = [[node.geometry.materials objectAtIndex:index] copy];
        [node.geometry replaceMaterialAtIndex:index withMaterial:unsharedMaterial];
        
        // Select the material.
        self.selectedMaterial = unsharedMaterial;
        
        // Animate the material.
        CABasicAnimation *highlightAnimation = [CABasicAnimation animationWithKeyPath:@"contents"];
        highlightAnimation.toValue = [NSColor blueColor];
        highlightAnimation.fromValue = [NSColor blackColor];
        highlightAnimation.repeatCount = MAXFLOAT;
        highlightAnimation.autoreverses = YES;
        highlightAnimation.duration = 0.5;
        highlightAnimation.timingFunction = [CAMediaTimingFunction functionWithName:kCAMediaTimingFunctionEaseInEaseOut];
        
        //[self.selectedMaterial.emission addAnimation:highlightAnimation forKey:@"highlight"];
    }
}

#pragma mark - Mouse events

- (IBAction)popupMenuChanged:(id)sender
{
	NSPopUpButton *popup = (NSPopUpButton*)sender;

	NSLog(@"switch: %ld", [[popup selectedItem] tag]);
	
	switch ([[popup selectedItem] tag]) {
		case 0: // visible
			self.sphereMaterial.ambient.contents = [NSImage imageNamed:@"eso0932a.png"];
			self.sphereMaterial.diffuse.contents = [NSImage imageNamed:@"eso0932a.png"];
			break;
		case 1: // WMAP
			self.sphereMaterial.ambient.contents = [NSImage imageNamed:@"wmap_ilc_7yr_v4_200uK_RGB_sos"];
			self.sphereMaterial.diffuse.contents = [NSImage imageNamed:@"wmap_ilc_7yr_v4_200uK_RGB_sos"];
			break;
		case 2: // dark matter
			self.sphereMaterial.ambient.contents = [NSImage imageNamed:@"dark-matter"];
			self.sphereMaterial.diffuse.contents = [NSImage imageNamed:@"dark-matter"];
			break;
		case 3: // 2MASS
			self.sphereMaterial.ambient.contents = [NSImage imageNamed:@"allsky-2mass"];
			self.sphereMaterial.diffuse.contents = [NSImage imageNamed:@"allsky-2mass"];
			break;
		case 4: // IRAS
			self.sphereMaterial.ambient.contents = [NSImage imageNamed:@"allsky-2mass"];
			self.sphereMaterial.diffuse.contents = [NSImage imageNamed:@"allsky-2mass"];
			break;
		case 5: // WISE
			self.sphereMaterial.ambient.contents = [NSImage imageNamed:@"WISE-PIA15482"];
			self.sphereMaterial.diffuse.contents = [NSImage imageNamed:@"WISE-PIA15482"];
			break;
		case 6: // Moon
			self.sphereMaterial.diffuse.contents = [NSImage imageNamed:@"moon-2048"];
			self.sphereMaterial.ambient.contents = [NSImage imageNamed:@"moon-2048"];
			break;
		case 7: // Mars
			self.sphereMaterial.ambient.contents = [NSImage imageNamed:@"4096"];
			self.sphereMaterial.diffuse.contents = [NSImage imageNamed:@"4096"];
			break;
		case 8: // Earth
			self.sphereMaterial.ambient.contents = [NSImage imageNamed:@"world.topo.bathy.200412.3x5400x2700"];
			self.sphereMaterial.diffuse.contents = [NSImage imageNamed:@"world.topo.bathy.200412.3x5400x2700"];
			break;
		default:
			;
	}
	self.sphere.materials = @[self.sphereMaterial];
}

#pragma mark - Mouse events

- (void)mouseMoved:(NSEvent *)event
{
	NSPoint mouseLocation = [self convertPoint:[event locationInWindow] fromView:nil];
	NSLog(@"mouse moved (%.3f, %.3f)", mouseLocation.x, mouseLocation.y);
}

- (void)mouseDown:(NSEvent *)event {
    // Convert the mouse location in screen coordinates to local coordinates, then perform a hit test with the local coordinates.
    NSPoint mouseLocation = [self convertPoint:[event locationInWindow] fromView:nil];
    NSArray *hits = [self hitTest:mouseLocation options:nil];
    
    // If there was a hit, select the nearest object; otherwise unselect.
    if ([hits count] > 0) {
        SCNHitTestResult *hit = hits[0]; // Choose the nearest object hit.
        [self selectNode:hit.node geometryElementIndex:hit.geometryIndex];
		
		NSLog(@"Local coordinates: %0.3f, %0.3f, %0.3f", hit.localCoordinates.x, hit.localCoordinates.y, hit.localCoordinates.z);
		NSLog(@"World coordinates: %0.3f, %0.3f, %0.3f", hit.worldCoordinates.x, hit.worldCoordinates.y, hit.worldCoordinates.z);
		
		CGPoint p = [hit textureCoordinatesWithMappingChannel:0];
		
		NSLog(@"Texture coordinates: %0.3f, %0.3f", p.x, p.y);
		
		self.textNode.position = hit.worldCoordinates;
    }
    else {
        [self selectNode:nil geometryElementIndex:NSNotFound];
    }
    
    [super mouseDown:event];
}

@end
